#include <stdio.h>
#include <math.h>
#include <signal.h>
#include <sys/wait.h>

extern int debug;

Beep(){
    putchar('\007');
}

BgSystemProcess(s)
char	*s;
{
int pid;
char	*argv[200];
char	tmpstr[200];
char	*sptr;
int		cnt;
short	string_on;

	strcpy(tmpstr,s);
	sptr = tmpstr;
	cnt = 0;
	/*
	* construct the damned argument list myself!
	*/
	while(*sptr != '\0'){
		/*
		* skip leading blanks
		*/
		string_on = 0;
		while((*sptr == ' ') || (*sptr == '\'')){
			if(*sptr = '\'') string_on = 1;
			sptr++;
		}
		/*
		* point to the beginning of the arg
		*/
		argv[cnt++] = sptr;
		/*
		* find the end of the arg
		*/
		while(((*sptr != ' ') || string_on) && (*sptr != '\0') && (*sptr != '\'')){
			sptr++;
		}
		/*
		* replace the space with a null
		*/
		if(*sptr != '\0') *sptr++ = '\0';
	}
	argv[cnt] = NULL;
	/*
	* do the fork
	*/
	pid = vfork();
	if(pid == -1){
		printf("run: fork unsucessful\n");
		_exit(0);
	} else 
	if(pid ==0){
		/*
		* execute the program
		*/
		execvp(argv[0],argv);
		printf("execve failed\n");
		_exit(0);
	}
}

ExecFork(argc,argv)
int	argc;
char	**argv;
{
int pid;
union wait status;
char	*newargv[4];
char	string[1000];
int	i;

    /*
    ** prepare the argument list for the fork
    */
    newargv[0] = "csh";
    newargv[1] = "-c";
    string[0] = '\0';
    for(i=0;i<argc;i++){
	strcat(string,argv[i]);
	strcat(string," ");
    }
    newargv[2] = string;
    newargv[3] = NULL;
    /*
    ** do the fork
    */
    pid = vfork();
    if(pid == -1){
	printf("run: fork unsucessful\n");
	_exit(0);
    } else 
    if(pid ==0){
	/*
	** pid = 0 indicates that this is the child resulting
	** from the fork so execute the program 
	** which overlays the current process and therefore
	** does not return
	*/
	execvp(newargv[0],newargv);
	/*
	** if the exec fails then exit the child
	*/
	printf("unable to execute '%s'\n",argv[0]);
	_exit(0);
    }
#ifdef DEBUG
    printf("waiting for child process %d\n",pid);
#endif
    /*
    ** pid > 0 indicates successful child has been forked
    ** so wait for it to complete execution and return the status
    */
    while(wait(&status) != pid);
    if(debug){
	printf("child process %d done. Status = %d\n",
	pid,
	status.w_status);
    }
    return(status.w_status);
}
